// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: SMBslave.c
* - ߲		: IAR EWAAVR 4.10b
*
* - xҰ		: avr@atmel.com
*
* - x޲	: TWIgp\ȑSAVR޲
*				  ATmega32pɏĂ܂B
*
* - pLq	: AVR316 - SMBus]u
*
* - 		: SMBusײގ(ް̑M)
*
* $Revision: 1.5 $
* $Date: Thursday, September 29, 2005 12:10:38 UTC $
*****************************************************************************/

#include <ioavr.h>
#include <inavr.h>
#include "SMBSlave.h"
#include "SMBExample.h"
#include "device_specific.h"

static SMBData smb;		//!< SMBusײން

/*! \brief TWI
 *
 * ̊֐TWISMBuspɏ܂B
 */
void SMBusInit()
{
  TWAR = SMB_OWN_ADDRESS << 1;										// g̏]uڽݒ
  TWCR = (1 << TWINT) | (1 << TWEN) | (1 << TWIE) | (1 << TWEA);	// TWI荞ݗv׸މ(0),TWI,TWI荞݋,ACKw
}

/*! \brief SMBusײދ
 *
 * ̊֐SMBusɉĂ̑uɊւʐM܂B
 */
void SMBEnable(void)
{
  smb.enable = TRUE;	// SMBusײދ
}

/*! \brief SMBusײދ֎~
 *
 * ̊֐SMBusɉĂ̑uɊւʐM֎~܂B
 * ]uڽSMBus 2.0dlɏ]ĖACK邱ƂɒӂĂB
 */
void SMBDisable(void)
{
  smb.enable = FALSE;	// SMBusײދ֎~
}

/*! \brief ŏIүނɊւُ׸ގ擾
 *
 * ŌSMBusʐMɊւُ׸ނԂ܂B
 *
 *  \retval 1  ŏIʐMňُ킠B
 *  \retval 0  ŌSMBusʐM͐łB
 */
unsigned char SMBError(void)
{
  return smb.error;		// ُ׸ނƋɕA
}

/*! \brief TWI荞ٰ
 *
 * TWI荞ٰ
 */
#pragma vector = TWI_VECT
__interrupt void SMBus_ISR(void)
{
  unsigned char enableACK;
  unsigned char temp;

  enableACK = TRUE;			// ACKw苖(ٰݓŖmȋ֎~w莞ȊO̊)

  if (smb.state == SMB_STATE_IDLE)		// ُԂŁASMBusϐ
  {
	smb.txLength = 0;					// M
	smb.txCount = 0;					// Mv
	smb.rxCount = 0;					// Mv
	smb.error = FALSE;					// ُ׸މ
#ifdef SMB_SUPPORT_PEC
	smb.pec = 0;						// PECLȂAPECl
#endif //SMB_SUPPORT_PEC

  }
  switch (TWSR & 0xF8)		// TWIԕΉ
  {
	case 0x60:					// SLA+WM,ACKԓ
	{
	// SLA+WMAԂͱقłׂłBSLA+WMꊎԂ
	// łȂ΁AAO̓]ł̎ɌołȂُ킪NĂ܂B
	// O̓]̋~ςɑ΂ĉł܂񂪁Ais̓]ł
	// 悤SMBusϐؾĂׂłB
	  if (smb.state != SMB_STATE_IDLE)	// ُԂłȂ΁A
	  {
		smb.txLength = 0;				// M
		smb.txCount = 0;				// Mv
		smb.rxCount = 0;				// Mv
		smb.error = FALSE;				// ُ׸މ
#ifdef SMB_SUPPORT_PEC
		smb.pec = 0;					// PECLȂAPECl
#endif //SMB_SUPPORT_PEC
	  }
	  smb.state = SMB_STATE_WRITE_REQUESTED;	// 呕ȕݗvԂɕύX

#ifdef SMB_SUPPORT_PEC
	  SMBcrc(SMB_OWN_ADDRESS_W);		// PECLȂASLA+WCRCvZ
#endif //SMB_SUPPORT_PEC
	  break;
	}

	case 0x80:					// SLA+Wڽw蒆ްM,ACKԓ
	{
	  temp = TWDR;							// Mް擾
	  smb.rxBuffer[smb.rxCount] = temp;		// MްMޯ̧֊i[
	  smb.rxCount++;						// Mvis
#ifdef SMB_SUPPORT_PEC
	  SMBcrc(temp);							// PECLȂAMްCRCvZ
#endif
            // If the receive buffer is full, disable ACKing of the next data byte.
	  if (smb.rxCount == SMB_RX_BUFFER_LENGTH)	// Mޯ̧tŁA
	  {
		enableACK = FALSE;					// ACKw֎~(NACKw)
	  }
	  break;
	}

	case 0x88:					// SLA+Wڽw蒆ްM,NACKԓ
	{
	  smb.error = TRUE;					// ُ׸ސݒ
	  smb.state = SMB_STATE_IDLE;		// ُԂɕύX
	  break;
	}

	case 0xa0:					// SLAڽw蒆ɒ~܂͍đJnM
	{
	  ProcessMessage(&smb);				// үޏ
	  break;
	}

	case 0xa8:					// SLA+RM,ACKԓ
	{
#ifdef SMB_SUPPORT_PEC
	  SMBcrc(SMB_OWN_ADDRESS_R);		// PECLȂASLA+RCRCvZ
#endif
	  if (smb.state == SMB_STATE_IDLE)	// ُԂŁA
	  {
		ProcessReceiveByte(&smb);				// 呕uǂݍ(]uM)ް
		smb.state = SMB_STATE_READ_REQUESTED;	// 呕u̓ǂݍݗvԔԍ
	  }	// 擪޲đM
	  temp = smb.txBuffer[0];			// Mޯ̧擪Mް擾
	  TWDR = temp;						// 擪Mlݒ
	  smb.txCount++;					// Mvis
#ifdef SMB_SUPPORT_PEC
	  SMBcrc(temp);						// PECLȂAMް ޲ĂCRCvZ
#endif
	  break;
	}

	case 0xb8:					// ް ޲đM,ACKM
	{
	  if (smb.txCount == smb.txLength)	// ŏI޲đMς݂ŁA
	  {
#ifdef SMB_SUPPORT_PEC
		TWDR = smb.pec;					// PECLȂAPECMݒ
#else
		smb.error = TRUE;				// PECȂȂAُ׸ސݒ(ŏI޲Ăɑ΂ACK̂)
#endif //SMB_SUPPORT_PEC
		enableACK = FALSE;				// ACKw֎~(NACKw)
	  }
	  else								// ŏI޲ĖMŁA
	  {
		temp = smb.txBuffer[smb.txCount];	// Mޯ̧Ή޲Ēl擾
		TWDR = temp;						// Ή޲đMݒ
		smb.txCount++;						// Mvis
#ifdef SMB_SUPPORT_PEC
		SMBcrc(temp);						// PECLȂAMް ޲ĂCRCvZ
#endif
	  }
	  break;
	}

	case 0xc0:					// ް ޲đM,NACKM
	{
	  if (smb.txCount != smb.txLength)	// ŏI޲ĖMŁA
	  {
		smb.error = TRUE;				// ُ׸ސݒ(ŏI޲ĈȑONACK̂)
	  }
	  smb.state = SMB_STATE_IDLE;		// ُԂɕύX
	  break;
	}

	case 0xc8:					// ŏIް ޲đM,ACKM
	{
	  smb.error = TRUE;					// ُ׸ސݒ(ŏI޲Ăɑ΂ACK̂)
	  smb.state = SMB_STATE_IDLE;		// ُԂɕύX
	  break;
	}

	case 0x00:					// s@ȊJn܂͒~̂߂޽ُ
	{
	  TWCR |= (1 << TWSTO);				// ~ow
	  smb.error = TRUE;					// ُ׸ސݒ
	  smb.state = SMB_STATE_IDLE;		// ُԂɕύX
	  break;
	}

	default:					// \ȂTWIԕ
	{
	  smb.error = TRUE;					// ُ׸ސݒ
	  smb.state = SMB_STATE_IDLE;		// ُԂɕύX
	  break;
	}
  }
  // TWIJn(TWINT̉(0)ŊJn)
  if (enableACK)				// ACKw苖ŁA
  {	// TWEAݒœTWINTȂ߂ɊԐړIɐݒ
	temp = TWCR;				// TWIڼ޽l擾
	temp |= (1 << TWEA);		// ȍ~ACKwޯĈʒu=1w
	temp &= ~(1 << TWINT);		// TWI荞ݗv׸ ޯĈʒu=0w
	TWCR = temp;				// ȍ~ACKw(TWI荞ݗv׸ޕۑ)
  }
  else							// ACKw֎~ŁA
  {
	TWCR &= ~((1 << TWEA) | (1 << TWINT));	// TWEAޯĉ(0),(TWINT׸ނ̏ԕێɒ)
  }
  TWCR |= (1 << TWEN) | (1 << TWIE) | (1 << TWINT);		// TWI,TWI荞݋,TWI荞ݗv׸މ(0)
  // TWEN,TWIE͊ɋATWINT̉ݎwĂ铮Jn܂B
}

#ifdef SMB_USE_PEC_LOOKUP
//! ׯ ؓɊi[CRClQƕ\
unsigned __flash char crcTable[256] = {
  0x00, 0x07, 0x0E, 0x09, 0x1C, 0x1B, 0x12, 0x15,
  0x38, 0x3F, 0x36, 0x31, 0x24, 0x23, 0x2A, 0x2D,
  0x70, 0x77, 0x7E, 0x79, 0x6C, 0x6B, 0x62, 0x65,
  0x48, 0x4F, 0x46, 0x41, 0x54, 0x53, 0x5A, 0x5D,
  0xE0, 0xE7, 0xEE, 0xE9, 0xFC, 0xFB, 0xF2, 0xF5,
  0xD8, 0xDF, 0xD6, 0xD1, 0xC4, 0xC3, 0xCA, 0xCD,
  0x90, 0x97, 0x9E, 0x99, 0x8C, 0x8B, 0x82, 0x85,
  0xA8, 0xAF, 0xA6, 0xA1, 0xB4, 0xB3, 0xBA, 0xBD,
  0xC7, 0xC0, 0xC9, 0xCE, 0xDB, 0xDC, 0xD5, 0xD2,
  0xFF, 0xF8, 0xF1, 0xF6, 0xE3, 0xE4, 0xED, 0xEA,
  0xB7, 0xB0, 0xB9, 0xBE, 0xAB, 0xAC, 0xA5, 0xA2,
  0x8F, 0x88, 0x81, 0x86, 0x93, 0x94, 0x9D, 0x9A,
  0x27, 0x20, 0x29, 0x2E, 0x3B, 0x3C, 0x35, 0x32,
  0x1F, 0x18, 0x11, 0x16, 0x03, 0x04, 0x0D, 0x0A,
  0x57, 0x50, 0x59, 0x5E, 0x4B, 0x4C, 0x45, 0x42,
  0x6F, 0x68, 0x61, 0x66, 0x73, 0x74, 0x7D, 0x7A,
  0x89, 0x8E, 0x87, 0x80, 0x95, 0x92, 0x9B, 0x9C,
  0xB1, 0xB6, 0xBF, 0xB8, 0xAD, 0xAA, 0xA3, 0xA4,
  0xF9, 0xFE, 0xF7, 0xF0, 0xE5, 0xE2, 0xEB, 0xEC,
  0xC1, 0xC6, 0xCF, 0xC8, 0xDD, 0xDA, 0xD3, 0xD4,
  0x69, 0x6E, 0x67, 0x60, 0x75, 0x72, 0x7B, 0x7C,
  0x51, 0x56, 0x5F, 0x58, 0x4D, 0x4A, 0x43, 0x44,
  0x19, 0x1E, 0x17, 0x10, 0x05, 0x02, 0x0B, 0x0C,
  0x21, 0x26, 0x2F, 0x28, 0x3D, 0x3A, 0x33, 0x34,
  0x4E, 0x49, 0x40, 0x47, 0x52, 0x55, 0x5C, 0x5B,
  0x76, 0x71, 0x78, 0x7F, 0x6A, 0x6D, 0x64, 0x63,
  0x3E, 0x39, 0x30, 0x37, 0x22, 0x25, 0x2C, 0x2B,
  0x06, 0x01, 0x08, 0x0F, 0x1A, 0x1D, 0x14, 0x13,
  0xAE, 0xA9, 0xA0, 0xA7, 0xB2, 0xB5, 0xBC, 0xBB,
  0x96, 0x91, 0x98, 0x9F, 0x8A, 0x8D, 0x84, 0x83,
  0xDE, 0xD9, 0xD0, 0xD7, 0xC2, 0xC5, 0xCC, 0xCB,
  0xE6, 0xE1, 0xE8, 0xEF, 0xFA, 0xFD, 0xF4, 0xF3
};

/* \brief PECCRCvZ(Qƕ\@)
 *
 * ̊֐͊Jn_܂ŌvZꂽPECgpA1޲ĂPECl擾ׯ ؂Ɋi
 * [ꂽQƕ\gp܂B
 *
 * \param  data    PECvZΏ޲Ēl
 * \param  pec     ݂PECl
 */
#pragma inline
static void SMBcrc(unsigned char data)	// (PECQƖ@IPEClvZ)
{
  smb.pec ^= data;				// ݂PEClƍ޲ĒlXOR
  smb.pec = crcTable[smb.pec];	// Qƕ\獡񌋉ʒl擾
}
#endif //SMB_USE_PEC_LOOKUP

#ifdef SMB_USE_PEC_CALCULATION
/* \brief PECCRCvZ(Z@)
 *
 * ̊֐͊Jn_܂ŌvZꂽPECgpA1޲ĂPEClvZ܂B
 *
 * \param  data    PECvZΏ޲Ēl
 * \param  pec     ݂PECl
 */
static void SMBcrc(unsigned char data)	// (PECvZ@IPEClvZ)
{
  unsigned char i;					// 8ޯ Čv

  smb.pec ^= data;					// Initial XOR

  i = 8;							// ޯČv평
  do								// (8ޯĕ)
  {
	if (smb.pec & 0x80)				// MSB(ʂX8)=1ŁA
	{
	  smb.pec <<= 1;				// 1ޯĈړ
	  smb.pec ^= SMB_CRC_POLYNOME;	// X2+X1+1̏(XOR)
	}
	else							// MSB(ʂX8)=0ŁA
	{
	  smb.pec <<= 1;				// 1ޯĈړ
	}
  }
  while(--i);
}
#endif //SMB_USE_PEC_CALCULATION
